unit MainDemo;

interface

uses
  SysUtils, Classes, DB,
  {$ifdef LINUX}
  QGraphics, QControls, QForms, QDialogs, QExtCtrls, QStdCtrls,
  QGrids, QDBGrids, QComCtrls, QActnList, QDBCtrls, QMask,
  {$else}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, ExtCtrls, StdCtrls,
  Grids, DBGrids, ComCtrls, ActnList, DBCtrls, Mask,
  {$endif}
  TdbDataSet;

type
  TRelationDemoForm = class(TForm)
    DemoDatabase: TTdbDatabase;
    Departmenttable: TTdbTable;
    EmployeeTable: TTdbTable;
    LocationTable: TTdbTable;
    LocationRelationTable: TTdbTable;
    LocationLookupTable: TTdbTable;
    ChainLocationTable: TTdbTable;
    ChainDepartmentTable: TTdbTable;
    ChainEmployeeTable: TTdbTable;
    DepartmentDataSource: TDataSource;
    EmployeeDataSource: TDataSource;
    LocationDataSource: TDataSource;
    PageControl1: TPageControl;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    OneToManySheet: TTabSheet;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    Splitter1: TSplitter;
    ManyToManySheet: TTabSheet;
    Label3: TLabel;
    DBGrid3: TDBGrid;
    Splitter2: TSplitter;
    Label4: TLabel;
    DBGrid4: TDBGrid;
    DepartmentDataSourceNM: TDataSource;
    Label5: TLabel;
    Label7: TLabel;
    DBNavigator1: TDBNavigator;
    Label2: TLabel;
    DBGrid2: TDBGrid;
    Panel2: TPanel;
    OneToManyActivBox: TCheckBox;
    DBNavigator2: TDBNavigator;
    DBNavigator3: TDBNavigator;
    DBNavigator4: TDBNavigator;
    Panel3: TPanel;
    ManyToManyBox: TCheckBox;
    Label8: TLabel;
    ManyToManyEnhancedSheet: TTabSheet;
    Label9: TLabel;
    Label10: TLabel;
    DBNavigator5: TDBNavigator;
    DBGrid5: TDBGrid;
    Splitter3: TSplitter;
    Label11: TLabel;
    DBNavigator6: TDBNavigator;
    Panel4: TPanel;
    DBEdit4: TDBEdit;
    DBEdit1: TDBEdit;
    DBGrid6: TDBGrid;
    Splitter4: TSplitter;
    Label12: TLabel;
    DBGrid7: TDBGrid;
    LocationRelationDataSource: TDataSource;
    Label14: TLabel;
    LocationLookupDataSource: TDataSource;
    Label16: TLabel;
    Panel5: TPanel;
    ManyToManyBox2: TCheckBox;
    ChainedTablesSheet: TTabSheet;
    Label17: TLabel;
    Label18: TLabel;
    DBNavigator7: TDBNavigator;
    DBGrid8: TDBGrid;
    Splitter5: TSplitter;
    Label19: TLabel;
    DBNavigator8: TDBNavigator;
    DBGrid9: TDBGrid;
    Splitter6: TSplitter;
    Label20: TLabel;
    DBNavigator9: TDBNavigator;
    DBGrid10: TDBGrid;
    ChainDepartmentDataSource: TDataSource;
    ChainLocationDataSource: TDataSource;
    ChainEmployeeDataSource: TDataSource;
    DBNavigator10: TDBNavigator;
    LocationTableCity: TTdbStringField;
    LocationTableStreet: TTdbStringField;
    LocationTablePhone: TTdbStringField;
    LocationTableRecordId: TAutoIncField;
    ChainLocationTableCity: TTdbStringField;
    ChainLocationTableStreet: TTdbStringField;
    ChainLocationTablePhone: TTdbStringField;
    ChainLocationTableRecordId: TAutoIncField;
    ChainEmployeeTableName: TTdbStringField;
    ChainEmployeeTableFirstName: TTdbStringField;
    ChainEmployeeTableEMail: TTdbStringField;
    ChainEmployeeTableSalary: TFloatField;
    ChainEmployeeTableRecordId: TAutoIncField;
    DepartmenttableName: TTdbStringField;
    DepartmenttableHomepage: TTdbStringField;
    DepartmenttableCity: TTdbStringField;
    DepartmenttableRecordId: TAutoIncField;
    ChainDepartmentTableName: TTdbStringField;
    ChainDepartmentTableHomepage: TTdbStringField;
    ChainDepartmentTableRecordId: TAutoIncField;
    ChainDepartmentTableCity: TTdbStringField;
    ChainEmployeeTableDepartment: TTdbStringField;
    EmployeeTableName: TTdbStringField;
    EmployeeTableFirstName: TTdbStringField;
    EmployeeTableEMail: TTdbStringField;
    EmployeeTableSalary: TFloatField;
    EmployeeTableRecordId: TAutoIncField;
    EmployeeTableDepartment: TTdbStringField;
    DepartmentTableNM: TTdbTable;
    LocationRelationTableRDepartment: TTdbStringField;
    LocationRelationTableRLocation: TTdbStringField;
    LocationLookupTableCity: TTdbStringField;
    LocationLookupTableStreet: TTdbStringField;
    LocationLookupTablePhone: TTdbStringField;
    LocationLookupTableRecordId: TAutoIncField;
    LocationRelationTableLocationLookup: TStringField;
    DepartmentLookupTable: TTdbTable;
    DepartmentLookupDataSource: TDataSource;
    DepartmentLookupTableName: TTdbStringField;
    DepartmentLookupTableHomepage: TTdbStringField;
    DepartmentLookupTableCity: TTdbStringField;
    DepartmentLookupTableRecordId: TAutoIncField;
    EmployeeTableDepartmentLookup: TStringField;
    ChainEmployeeTableDepartmentLookup: TStringField;
    DepartmentTableNMName: TTdbStringField;
    DepartmentTableNMHomepage: TTdbStringField;
    DepartmentTableNMCity: TTdbStringField;
    DepartmentTableNMRecordId: TAutoIncField;
    procedure ToggleEmployeeLinkExecute(Sender: TObject);
    procedure ManyToManyBox2Click(Sender: TObject);
    procedure ManyToManyBoxClick(Sender: TObject);
    procedure LocationRelationTableAfterPost(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    procedure EmployeeTableAfterPost(DataSet: TDataSet);
  private
    { Private-Deklarationen }
    procedure ToggleLocationRelationExecute(Sender: TObject);
		procedure RefreshMasterSource(Table: TTdbTable);
  public
    { Public-Deklarationen }
  end;

var
  RelationDemoForm: TRelationDemoForm;

implementation

{$ifdef LINUX}
{$R *.xfm}
{$else}
{$R *.DFM}
{$endif}

procedure TRelationDemoForm.EmployeeTableAfterPost(DataSet: TDataSet);
begin
	RefreshMasterSource(DataSet as TTdbTable);
end;


procedure TRelationDemoForm.FormCreate(Sender: TObject);
begin
  DemoDatabase.Connected := False;
	DemoDatabase.Directory := ExtractFilePath(Application.ExeName);
  DemoDatabase.Connected := True;
  // Alle Tabellen ffnen
  Departmenttable.Open;
  EmployeeTable.Open;
  LocationTable.Open;
  LocationLookupTable.Open;
  DepartmentTableNM.Open;
  LocationRelationTable.Open;
  LocationLookupTable.Open;
  ChainLocationTable.Open;
  ChainDepartmentTable.Open;
  ChainEmployeeTable.Open;
  PageControl1.ActivePage := OneToManySheet;

end;


procedure TRelationDemoForm.LocationRelationTableAfterPost(DataSet: TDataSet);
begin
	RefreshMasterSource(DataSet as TTdbTable);
end;


procedure TRelationDemoForm.ManyToManyBox2Click(Sender: TObject);
begin
	ManyToManyBox.Checked := ManyToManyBox2.Checked;
	ToggleLocationRelationExecute(Sender);
end;


procedure TRelationDemoForm.ManyToManyBoxClick(Sender: TObject);
begin
	ManyToManyBox2.Checked := ManyToManyBox.Checked;
	ToggleLocationRelationExecute(Sender);
end;


procedure TRelationDemoForm.RefreshMasterSource(Table: TTdbTable);
begin
	Table.MasterSource.DataSet.Refresh;
end;


procedure TRelationDemoForm.ToggleEmployeeLinkExecute(Sender: TObject);
begin
	if EmployeeTable.MasterSource = nil then
  	EmployeeTable.MasterSource := DepartmentDataSource
	else
  	EmployeeTable.MasterSource := nil;
  OneToManyActivBox.Checked := EmployeeTable.MasterSource <> nil;
end;


procedure TRelationDemoForm.ToggleLocationRelationExecute(Sender: TObject);
begin
	if ManyToManyBox.Checked then
  	DepartmentTableNM.MasterSource := LocationDataSource
	else
  	DepartmentTableNM.MasterSource := nil
end;
end.
